package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.sd1.task1.model.Employee;

/**
 * <p>Student grade and overall status.</p>
 */
public class _1_Grade {

    /**
     * <p>Create an individual student's overall success exam status message.</p>
     *
     * <p>First year students are supposed to take three exams e.g. Geometry, Algebra, and Physics. Each possible
     * grade outcome ranges from 1 (very good) to 6 (insufficient).</p>
     *
     * <p>This method creates an overall message describing the student's performance based on
     * the three grades' average:</p>
     *
     * <table class="goikTableDefaults">
     *     <caption>Students' grade averages and derived performance indication.</caption>
     *     <tbody>
     *         <tr>
     *             <th>Grade average</th>
     *             <th>Status text</th>
     *         </tr>
     *         <tr>
     *             <td>2 (inclusive) or better</td>
     *             <td><code>"Your average score is 2 or better, good job!"</code></td>
     *         </tr>
     *
     *         <tr>
     *             <td>In between 2 (exclusive) and 3 (inclusive)</td>
     *             <td><code>"Your average score is 3 or better, you need to work harder!"</code></td>
     *         </tr>
     *
     *         <tr>
     *             <td>Otherwise</td>
     *             <td><code>"You really need to work harder!"</code></td>
     *         </tr>
     *
     *     </tbody>
     *
     * </table>
     *
     * <p>Example: A student having grades 1, 4 and 3 has got an average of 2.66... being within
     * ]2, 3] thus receiving <code>"Your average score is 3 or better, you need to work harder!"</code>.</p>
     *
     * @param grade1 First exam's marking
     * @param grade2 Second exam's marking
     * @param grade3 Third exam's marking
     * @return An informal status message as being described above.
     *
     * <section class="implementationHints">
     *    <h4>Caution:</h4>
     *
     *    <p>With respect to unit tests really copy the desired messages: Using e.g.
     *    <code style="font-weight: bold">"... better,good ..."</code> rather than
     *    <code style="font-weight: bold">"... better, good ..."</code>
     *    (missing space character after comma) will cause
     *    all unit tests to fail.</p>
     * </section>
     */
    static public String describePersonalSuccess(final int grade1, final int grade2, final int grade3) {

        final int sum =  grade1 + grade2 + grade3;

        if (sum <= 6) {
            return "Your average score is 2 or better, good job!";
        } else if (sum <= 9) {
            return "Your average score is 3 or better, you need to work harder!";
        } else {
            return "You really need to work harder!";
        }
    }

    private _1_Grade(){/* Ignore me: Suppressing default constructor javadoc generation:
                              javadoc does not include private constructors by default */}
}
