package de.hdm_stuttgart.mi.sd1.task1.model;

import de.hdm_stuttgart.mi.sd1.task1._4_Salary;

/**
 * <p><span style="color:red;font-weight: bold">Nothing to be done here!</span> This class is part of
 * implementing {@link _4_Salary}.</p>
 */
public class Employee {

    /**
     * <p>Creating an employee computing his/her salary by means of {@link #getSalary()}.</p>
     *
     * <p><span style="color:red;font-weight: bold">Nothing to be done here!</span> This class is part of
     *  implementing {@link _4_Salary}.</p>
     *
     * @param numberOfKids See {@link #numberOfKids}
     * @param yearsEmployed See {@link #yearsEmployed}
     */
    public Employee(final int numberOfKids, final int yearsEmployed) {
        this.numberOfKids = numberOfKids;
        this.yearsEmployed = yearsEmployed;
    }
    /**
     * <p>Compute an employee's salary.</p>
     *
     * <p>A company pays its employees according to the following rule:</p>
     *
     * <p>2000€ + 200€ * numberOfKids + 50€ * numberOfYearsEmployed</p>
     *
     * <p>An employee for example being employed for 10 years and having two kids will earn
     * 2000€ + 200€ * 2 + 50€ * 10 = 2900€.</p>
     *
     * <p>This regular salary is being multiplied and thus possibly limited by the {@link #salaryFraction}
     * property.</p>
     *
     * @return Salary depending on employee attributes
     */
     public int getSalary() {
        return (int) Math.round((2000 + 200 * numberOfKids + yearsEmployed * 50) * salaryFraction);
    }

    /**
     * An employee's number of kids.
     */
    public int numberOfKids;

    /**
     * The number of years an employee has been employed.
     */
    public int yearsEmployed;

    /**
     * An employee's fraction of salary. Usually 1.0 but smaller in case of economic slowdown.
     */
    static private double salaryFraction = 1.0;

    public static double getSalaryFraction() {
        return salaryFraction;
    }

    /**
     * <p>Overall parameter governing the payment of employees.</p>
     *
     * <p>This value will range between 0 and 1.0. An employee's regular salary will be fully paid if this parameter
     * equals 1.0. Lower values will cut salaries accordingly.</p>
     *
     * <p>Example: If {@link #salaryFraction} equals 0.7 all salaries will be limited to 70% of their regular values.</p>
     *
     * @param salaryFraction The factor possible limiting each employee's salary.
     */
    public static void setSalaryFraction(double salaryFraction) {
        Employee.salaryFraction = salaryFraction;
    }
}
